// V[gJbg̃tH_J܂
// 2002/06/04 Version 1.0

#include <cstdio>
#include <shlobj.h>
#include <sys/stat.h>

// V[gJbg̎擾
bool GetShortcutLink(LPSTR sShcut,LPSTR sTarget,int mx)
{
	bool			ret = false;
	HRESULT			res;
	IShellLink*		psl; 
	WIN32_FIND_DATA	wfd;
	CoInitialize(0);
	res = CoCreateInstance(CLSID_ShellLink,0,
		CLSCTX_INPROC_SERVER,IID_IShellLink,(void **)&psl);
	if (SUCCEEDED(res)) {
		IPersistFile*  ppf;
		res = psl->QueryInterface(IID_IPersistFile,(void **)&ppf);
		if (SUCCEEDED(res)) {
			WCHAR  wsShcut[MAX_PATH]; // Unicode p̃obt@
			MultiByteToWideChar(CP_ACP,0,sShcut,-1,wsShcut,MAX_PATH);
			if (SUCCEEDED(ppf->Load(wsShcut,STGM_READ)))
				ret = SUCCEEDED(psl->GetPath(sTarget,mx,&wfd,SLGP_UNCPRIORITY));
			ppf->Release();
		}
		psl->Release();
	}
	CoUninitialize();
	return ret;
}

int main(int argc,char** argv)
{
	const char*	title = strrchr(*argv,'\\');
	if (!title) title = *argv;
	else ++title;
	if (argc > 1) {
		struct stat	st;
		if (!stat(argv[1],&st) && (st.st_mode&S_IFDIR)) {
			ShellExecute(0,"open","cmd.exe",0,argv[1],SW_SHOW);
			return 0;
		}
		char	buf[256],*p;
		if (GetShortcutLink(argv[1],buf,sizeof(buf))) {
			p = strrchr(buf,'\\');
			if (p) {
				*p = 0;
				ShellExecute(0,"open",buf,0,0,SW_SHOW);
				return 0;
			}
		}
	}
	MessageBox(0,"Drag a shortcut or folder",title,MB_ICONINFORMATION);
	return 0;
}